<template>
<div class="wrapper">
  <label>
    <input
    :type="type"
    :value="value"
    :placeholder="placeholder"
    @input="onInput"/>
    {{ label }}
  </label>
</div>
</template>

<script>
export default {
  name: 'AppInput',
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        return [
          'email',
          'text',
          'password',
        ].indexOf(value) !== -1;
      },
    },
    label: {
      type: String,
      required: false,
    },
    value: {
      type: String,
      required: false,
    },
    placeholder: {
      type: String,
      required: false,
    },
  },
  methods: {
    onInput($event) {
      this.$emit('input', $event.target.value);
    },
  },
};
</script>

<style lang="scss" scoped>
@import '~styles/colors.scss';

.wrapper {
  margin: 1em;
  padding: 0.4em 0;
  border-radius: 0.3em;

  background-color: transparent;
  background-image: none; /* Without this gradient in the parent element looks broken */

  input {
    width: 350px;
    padding: 0.7em 0.6em;

    border: none;
    border-radius: 0.2em;

    font-size: 1.2em;
    color: $text-primary;
  }

  input:focus {
    outline: none;

    box-shadow: 0 0 20px $gradient-left;
  }
}

@media screen and (max-width: 768px) {
  .wrapper {
    input {
      width: 250px;
    }
  }
}
</style>
